var port = null;
var portContent = {};

chrome.runtime.onConnect.addListener(function(port) {
    portContent[port.name] = port;
});

function processOperation(data, sender, response) {
    try {
        var idPortaComunicacao = data.sessionId;
	      connect();
        port.postMessage( data );
	      port.onMessage.addListener(function(msg) {
          portContent[idPortaComunicacao].postMessage(msg);
	      });
    }
    catch( e ) {
        console.log(e.message);
    }
}

chrome.runtime.onMessage.addListener(processOperation);

function connect(){
	if(!port) {
		var application = 'signa.extension';

		if(!chrome.runtime) {
			chrome.runtime = chrome.extension;
		}
    port = chrome.runtime.connectNative(application);
    port.onDisconnect.addListener(function() {
      port=null;
      chrome.runtime.lastError.message.indexOf("not found") !== -1
      if (chrome.runtime.lastError.message.indexOf("not found") !== -1){
        alert("A aplicação Signa - Prodemge não foi instalada no computador. Favor fazer a instalação.")
      }
    });
	}
}
