
var extId = "idbpfpeogbhifooiagnbbdbffplkfcke";


// contentscript.js

window.addEventListener('message', function(event) {
	// We only accept messages from ourselves
	if (event.source != window) {
		return;
	}

	if (event.data.type && (event.data.type == 'INICIAR_SIGNA')) {

		var id = event.data.sessionId;
	
		var port = chrome.runtime.connect({name: id});
			port.onMessage.addListener(function(msg) {
				if (msg.atualizar){
					alterarMensagemStatus(msg.message);
				} else if (msg.sucesso) {
					fecharPopup(true);
				} else if(msg.erro){
					alterarMensagemStatus(msg.message);
					fecharPopup(false);
				}
			});

			chrome.runtime.sendMessage(event.data);
	}
}, false);


function alterarMensagemStatus(msg) {
	if(navigator.appName.indexOf("Internet Explorer")!=-1){
		document.getElementById("statusMessage").innerText = msg;
	} else {
		document.getElementById("statusMessage").textContent = msg;
	}
}

function fecharPopup(status){
		window.postMessage({
			type: 'FECHAR_POPUP',
			status: status
		}, '*');
}

var newdiv = document.createElement('div');
newdiv.setAttribute('id',extId);
document.body.appendChild(newdiv);
